# Joinery's More Summary Fields
## ReadMe

Provides additional fields under the [Summary Fields](https://civicrm.org/extensions/summary-fields) framework.

## Requirements

* [Summary Fields](https://civicrm.org/extensions/summary-fields) Extension

## Additional fields

This extension currently provides the following fields:

* CiviContribute: Total Contributions this calendar year (also: renames Summary Fields "Total Contributions this year" to "Total Contributions this fiscal year")
* CiviContribute: Total Contributions last calendar year (also: renames Summary Fields "Total Contributions last year" to "Total Contributions last fiscal year")
* CiviContribute: Total Contributions Calendar Year Before Last (also: renames Summary Fields "Total Contributions Year Before Last" to "Total Contributions Fiscal Year Before Last")
* CiviContribute: Lifetime contributions + soft credits
* CiviContribute: Number of years of contributions
* CiviContribute: Total soft credits this calendar year
* CiviContribute: Total soft credits previous calendar year
* CiviContribute: Total soft credits previous fiscal year
* CiviContribute/Relationship: Related contact contributions this fiscal year
* CiviContribute/Relationship: Related contact contributions this calendar year
* CiviContribute/Relationship: Related contact contributions last fiscal year
* CiviContribute/Relationship: Related contact contributions last calendar year
* CiviContribute/Relationship: Related contact contributions year before last calendar year
* CiviContribute/Relationship: Related contact contributions all time
* CiviContribute/Relationship: Combined contact & related contact contributions this fiscal year
* CiviContribute/Relationship: Combined contact & related contact contributions this calendar year
* CiviContribute/Relationship: Combined contact & related contact contributions last fiscal year
* CiviContribute/Relationship: Combined contact & related contact contributions year before last calendar year 
* CiviContribute/Relationship: Combined contact & related contact contributions last calendar year
* CiviContribute/Relationship: Combined contact & related contact contributions all time
* CiviEvents: Date of the first attended event
* CiviMail: CiviMail open rate (all time)
* CiviMail: CiviMail open rate (last 12 months)
* CiviMail: CiviMail click-through rate (all time)
* CiviGrant: Total number of grants received
* CiviGrant: Total $ in grants received
* CiviGrant: Grant types received

## Developer notes
See [DEVNOTES.md](DEVNOTES.md).

## Support
![screenshot](/images/joinery-logo.png)

Joinery provides services for CiviCRM including custom extension development, training, data migrations, and more. We aim to keep this extension in good working order, and will do our best to respond appropriately to issues reported on its [github issue queue](https://github.com/twomice/com.joineryhq.jsumfields/issues). In addition, if you require urgent or highly customized improvements to this extension, we may suggest conducting a fee-based project under our standard commercial terms.  In any case, the place to start is the [github issue queue](https://github.com/twomice/com.joineryhq.jsumfields/issues) -- let us hear what you need and we'll be glad to help however we can.

And, if you need help with any other aspect of CiviCRM -- from hosting to custom development to strategic consultation and more -- please contact us directly via https://joineryhq.com
