<?php

use CRM_FormProcessor_ExtensionUtil as E;

/**
 * @author Jaap Jansma (CiviCooP) <jaap.jansma@civicoop.org>
 * @license http://www.gnu.org/licenses/agpl-3.0.html
 */
class CRM_FormProcessor_DAO_FormProcessorAction extends CRM_Core_DAO {
  /**
   * static instance to hold the field values
   *
   * @var array
   * @static
   */
  static $_fields = null;
  static $_export = null;
  /**
   * empty definition for virtual function
   */
  static function getTableName() {
    return 'civicrm_form_processor_action';
  }
  /**
   * returns all the column names of this table
   *
   * @access public
   * @return array
   */
  public static function &fields() {
    if (!(self::$_fields)) {
      self::$_fields = array(
        'id' => array(
          'name' => 'id',
          'title' => E::ts('ID'),
          'type' => CRM_Utils_Type::T_INT,
          'required' => true
        ),
        'form_processor_instance_id' => array(
          'name' => 'form_processor_instance_id',
          'title' => E::ts('Form Processor ID'),
          'type' => CRM_Utils_Type::T_INT,
          'required' => true,
          'FKApiName' => 'FormProcessorInstance',
        ),
        'weight' => array(
          'name' => 'weight',
          'title' => E::ts('Weight'),
          'type' => CRM_Utils_Type::T_INT,
          'required' => true,
        ),
        'name' => array(
          'name' => 'name',
          'title' => E::ts('Name'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 80,
        ) ,
        'title' => array(
          'name' => 'title',
          'title' => E::ts('Title'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 80,
          'required' => true,
        ) ,
        'type' => array(
          'name' => 'type',
          'title' => E::ts('Type'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 80,
          'required' => true,
        ),
        'configuration' => array(
          'name' => 'configuration',
          'title' => E::ts('Configuration'),
          'type' => CRM_Utils_Type::T_TEXT,
        ),
        'mapping' => array(
          'name' => 'mapping',
          'title' => E::ts('Mapping'),
          'type' => CRM_Utils_Type::T_TEXT,
        ),
        'condition_configuration' => array(
          'name' => 'condition_configuration',
          'title' => E::ts('Condition configuration'),
          'type' => CRM_Utils_Type::T_TEXT,
        ),
        'delay' => array(
          'name' => 'delay',
          'title' => E::ts('Delay'),
          'type' => CRM_Utils_Type::T_STRING,
          'maxlength' => 255,
          'required' => true,
        ),
        'delay_configuration' => array(
          'name' => 'delay_configuration',
          'title' => E::ts('Delay configuration'),
          'type' => CRM_Utils_Type::T_TEXT,
        ),
      );
    }
    return self::$_fields;
  }
  /**
   * Returns an array containing, for each field, the array key used for that
   * field in self::$_fields.
   *
   * @access public
   * @return array
   */
  public static function &fieldKeys() {
    if (!(self::$_fieldKeys)) {
      self::$_fieldKeys = array(
        'id' => 'id',
        'form_processor_instance_id' => 'form_processor_instance_id',
        'weight' => 'weight',
        'name' => 'name',
        'title' => 'title',
        'type' => 'type',
        'configuration' => 'configuration',
        'mapping' => 'mapping',
        'condition_configuration' => 'condition_configuration',
        'delay' => 'delay',
        'delay_configuration' => 'delay_configuration',
      );
    }
    return self::$_fieldKeys;
  }
  /**
   * returns the list of fields that can be exported
   *
   * @access public
   * return array
   * @static
   */
  static function &export($prefix = false)
  {
    if (!(self::$_export)) {
      self::$_export = array();
      $fields = self::fields();
      foreach($fields as $name => $field) {
        if (CRM_Utils_Array::value('export', $field)) {
          if ($prefix) {
            self::$_export['form_porcessor_action'] = & $fields[$name];
          } else {
            self::$_export[$name] = & $fields[$name];
          }
        }
      }
    }
    return self::$_export;
  }
}