<?php

use CRM_FormProcessor_ExtensionUtil as E;

/**
 * FormProcessorInput.Converttitletoname API
 *
 * @param array $params
 * @return array API result descriptor
 * @see civicrm_api3_create_success
 * @see civicrm_api3_create_error
 * @throws API_Exception
 */
function civicrm_api3_form_processor_input_converttitletoname($params) {
  $title = $params['title'];
  $returnValues['name'] = CRM_FormProcessor_BAO_FormProcessorInput::buildNameFromTitle($title);
  return $returnValues;
}

/**
 * FormProcessorInput.Converttitletoname API specification (optional)
 * This is used for documentation and validation.
 *
 * @param array $spec description of fields supported by this API call
 * @return void
 * @see http://wiki.civicrm.org/confluence/display/CRM/API+Architecture+Standards
 */
function _civicrm_api3_form_processor_input_converttitletoname_spec(&$spec) {
  $spec['title'] = array(
    'title' => E::ts('Title'),
    'type' => CRM_Utils_Type::T_STRING,
    'api.required' => true
  );
}