<?php

/**
 * FormProcessorInstance.List API
 *
 * @param array $params
 * @return array API result descriptor
 * @see civicrm_api3_create_success
 * @see civicrm_api3_create_error
 * @throws API_Exception
 */
function civicrm_api3_form_processor_instance_list($params) {
  $returnValues = array();
  $params['is_active'] = 1;
  $form_processors = \CRM_FormProcessor_BAO_FormProcessorInstance::getValues($params);
  foreach($form_processors as $form_processor) {
    $returnValues[$form_processor['name']] = array(
      'name' => $form_processor['name'],
      'title' => $form_processor['title'],
    );
  }
  return civicrm_api3_create_success($returnValues, $params, 'FormProcessorInstance', 'List');
}

