CREATE TABLE IF NOT EXISTS `civicrm_form_processor_instance` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(80) NULL,
  `title` VARCHAR(128) NULL,
  `is_active` TINYINT NULL DEFAULT 1,
  `description` TEXT NULL,
  `output_handler` VARCHAR(88) NOT NULL,
  `output_handler_configuration` TEXT NULL,
  `enable_default_data` TINYINT NOT NULL DEFAULT 0,
  `default_data_output_configuration` TEXT NULL,
  `created_date` DATE NULL,
  `created_user_id` INT NULL,
  `modified_date` DATE NULL,
  `modified_user_id` INT NULL,
  `permission` VARCHAR(255) NOT NULL DEFAULT '',
  `status` TINYINT NULL DEFAULT 1,
  `source_file` VARCHAR(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE INDEX `name_UNIQUE` (`name` ASC)
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS `civicrm_form_processor_input` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `form_processor_instance_id` INT UNSIGNED NOT NULL,
  `title` VARCHAR(128) NULL,
  `name` VARCHAR(80) NOT NULL,
  `type` VARCHAR(80) NOT NULL,
  `is_required` TINYINT NULL DEFAULT 0,
  `default_value` VARCHAR(256) NULL,
  `configuration` TEXT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `name_id_UNIQUE` (`form_processor_instance_id`, `name` ASC)
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS `civicrm_form_processor_validation` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `entity` VARCHAR (256) NOT NULL,
  `entity_id` INT UNSIGNED NOT NULL,
  `validator` VARCHAR(80) NOT NULL,
  `configuration` TEXT NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS `civicrm_form_processor_action` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `form_processor_instance_id` INT UNSIGNED NOT NULL,
  `weight` INT UNSIGNED NOT NULL,
  `name` VARCHAR(80) NOT NULL,
  `title` VARCHAR(80) NOT NULL,
  `type` VARCHAR(80) NOT NULL,
  `configuration` TEXT NULL,
  `mapping` TEXT NULL,
  `condition_configuration` TEXT NULL,
  `delay` VARCHAR(255) NULL,
  `delay_configuration` TEXT NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS `civicrm_form_processor_default_data_input` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `form_processor_instance_id` INT UNSIGNED NOT NULL,
  `title` VARCHAR(128) NULL,
  `name` VARCHAR(80) NOT NULL,
  `type` VARCHAR(80) NOT NULL,
  `is_required` TINYINT NULL DEFAULT 0,
  `default_value` VARCHAR(256) NULL,
  `configuration` TEXT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `name_id_UNIQUE` (`form_processor_instance_id`, `name` ASC)
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS `civicrm_form_processor_default_data_action` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `form_processor_instance_id` INT UNSIGNED NOT NULL,
  `weight` INT UNSIGNED NOT NULL,
  `name` VARCHAR(80) NOT NULL,
  `title` VARCHAR(80) NOT NULL,
  `type` VARCHAR(80) NOT NULL,
  `configuration` TEXT NULL,
  `mapping` TEXT NULL,
  `condition_configuration` TEXT NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB;
