{crmScope extensionKey='form-processor'}
{if ($enableDefault)}
<div class="crm-form-block">
  <div class="crm-accordion-wrapper crm-advanced_search_form-accordion">
    <div class="crm-accordion-header crm-master-accordion-header">{ts}Retrieve default data{/ts}</div>
    <div class="crm-accordion-body">
      <p class="help">
        {ts}With the retrieval of default data you can lookup existing data and then change it.{/ts}
      </p>
      {foreach from=$defaultFieldNames item=fieldName}
        <div class="crm-section">
          <div class="label">{$form.$fieldName.label}</div>
          <div class="content">{$form.$fieldName.html}</div>
          <div class="clear"></div>
        </div>
      {/foreach}
      <div class="crm-submit-buttons">

        {assign var='html' value=$form.buttons._qf_RunFormProcessor_refresh.html}
        {crmGetAttribute html=$html attr='crm-icon' assign='icon'}
        {capture assign=iconPrefix}{$icon|truncate:3:"":true}{/capture}
        {if $icon && $iconPrefix eq 'fa-'}
          {assign var='buttonClass' value=' crm-i-button'}
          {capture assign=iconDisp}<i class="crm-i {$icon}"></i>{/capture}
        {elseif $icon}
          {assign var='buttonClass' value=' crm-icon-button'}
          {capture assign=iconDisp}<span class="crm-button-icon ui-icon-{$icon}"> </span>{/capture}
        {/if}
        {crmGetAttribute html=$html attr='disabled' assign='disabled'}
        <span class="crm-button crm-button-type-{$key|crmBtnType} crm-button{$key}{$buttonClass}{if $disabled} crm-button-disabled{/if}"{if $buttonStyle} style="{$buttonStyle}"{/if}>
          {$iconDisp}
          {$html}
        </span>

      </div>
    </div>
  </div>
</div>
{/if}

<p class="help">
  <i class="crm-i fa-exclamation-triangle" aria-hidden="true">&nbsp;</i>{ts}<strong>Danger!</strong> Using the form below might change actual data. Use it with care.{/ts}
</p>
{foreach from=$fieldNames item=fieldName}
<div class="crm-section">
  <div class="label">{$form.$fieldName.label}</div>
  <div class="content">{$form.$fieldName.html}</div>
  <div class="clear"></div>
</div>
{/foreach}

<div class="crm-section">
  <div class="label">&nbsp;</div>
  <div class="content">
    {assign var='html' value=$form.buttons._qf_RunFormProcessor_submit.html}
    {crmGetAttribute html=$html attr='crm-icon' assign='icon'}
    {capture assign=iconPrefix}{$icon|truncate:3:"":true}{/capture}
    {if $icon && $iconPrefix eq 'fa-'}
      {assign var='buttonClass' value=' crm-i-button'}
      {capture assign=iconDisp}<i class="crm-i {$icon}"></i>{/capture}
    {elseif $icon}
      {assign var='buttonClass' value=' crm-icon-button'}
      {capture assign=iconDisp}<span class="crm-button-icon ui-icon-{$icon}"> </span>{/capture}
    {/if}
    {crmGetAttribute html=$html attr='disabled' assign='disabled'}
    <span class="crm-button crm-button-type-{$key|crmBtnType} crm-button{$key}{$buttonClass}{if $disabled} crm-button-disabled{/if}"{if $buttonStyle} style="{$buttonStyle}"{/if}>
      {$iconDisp}
      {$html}
    </span>
  </div>
  <div class="clear"></div>

  {if $result_json}
    <h3>{ts}Result{/ts}</h3>
    <pre>{$result_json|htmlentities}</pre>
  {/if}
</div>
{/crmScope}
