<?php

require_once 'liqpayintegration.civix.php';
use CRM_Liqpayintegration_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/ 
 */
function liqpayintegration_civicrm_config(&$config) {
  _liqpayintegration_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_xmlMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_xmlMenu
 */
function liqpayintegration_civicrm_xmlMenu(&$files) {
  _liqpayintegration_civix_civicrm_xmlMenu($files);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function liqpayintegration_civicrm_install() {
  _liqpayintegration_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_postInstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_postInstall
 */
function liqpayintegration_civicrm_postInstall() {
  _liqpayintegration_civix_civicrm_postInstall();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_uninstall
 */
function liqpayintegration_civicrm_uninstall() {
  _liqpayintegration_civix_civicrm_uninstall();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function liqpayintegration_civicrm_enable() {
  _liqpayintegration_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_disable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_disable
 */
function liqpayintegration_civicrm_disable() {
  _liqpayintegration_civix_civicrm_disable();
}

/**
 * Implements hook_civicrm_upgrade().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_upgrade
 */
function liqpayintegration_civicrm_upgrade($op, CRM_Queue_Queue $queue = NULL) {
  return _liqpayintegration_civix_civicrm_upgrade($op, $queue);
}

/**
 * Implements hook_civicrm_managed().
 *
 * Generate a list of entities to create/deactivate/delete when this module
 * is installed, disabled, uninstalled.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_managed
 */
function liqpayintegration_civicrm_managed(&$entities) {
  // Creates the payment processor entity for the LiqPay Payment Processor
  $entities[] = [
    'module' => E::LONG_NAME,
    'name' => 'LiqPay',
    'entity' => 'PaymentProcessorType',
    'params' => [
      'version' => 3,
      'name' => 'LiqPay',
      'title' => E::ts('LiqPay'),
      'description' => E::ts('LiqPay Payment Processor'),
      'class_name' => 'Payment_Liqpay',
      'billing_mode' => '4',
      'user_name_label' => E::ts('Public key'),
      'password_label' => E::ts('Private key'),
      'url_site_default' => 'https://www.liqpay.ua/',
      'url_site_test_default' => 'https://www.liqpay.ua/',
      'is_recur' => 1,
      'payment_type' => 1,
    ],
    'metadata' => [
      'suppress_submit_button' => 1,
      'payment_fields' => ['payment_token'],
    ],
  ];

  return _liqpayintegration_civix_civicrm_managed($entities);
}

/**
 * Implements hook_civicrm_caseTypes().
 *
 * Generate a list of case-types.
 *
 * Note: This hook only runs in CiviCRM 4.4+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_caseTypes
 */
function liqpayintegration_civicrm_caseTypes(&$caseTypes) {
  _liqpayintegration_civix_civicrm_caseTypes($caseTypes);
}

/**
 * Implements hook_civicrm_angularModules().
 *
 * Generate a list of Angular modules.
 *
 * Note: This hook only runs in CiviCRM 4.5+. It may
 * use features only available in v4.6+.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_angularModules
 */
function liqpayintegration_civicrm_angularModules(&$angularModules) {
  _liqpayintegration_civix_civicrm_angularModules($angularModules);
}

/**
 * Implements hook_civicrm_alterSettingsFolders().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_alterSettingsFolders
 */
function liqpayintegration_civicrm_alterSettingsFolders(&$metaDataFolders = NULL) {
  _liqpayintegration_civix_civicrm_alterSettingsFolders($metaDataFolders);
}

/**
 * Implements hook_civicrm_entityTypes().
 *
 * Declare entity types provided by this module.
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_entityTypes
 */
function liqpayintegration_civicrm_entityTypes(&$entityTypes) {
  _liqpayintegration_civix_civicrm_entityTypes($entityTypes);
}

/**
 * Implements hook_civicrm_thems().
 */
function liqpayintegration_civicrm_themes(&$themes) {
  _liqpayintegration_civix_civicrm_themes($themes);
}
