<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from org.civicoop.civirules/xml/schema/CRM/Civirules/Rule.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:bb6208fe19fc8a273c310b1ca25bf2b8)
 */
use CRM_Civirules_ExtensionUtil as E;

/**
 * Database access object for the Rule entity.
 */
class CRM_Civirules_DAO_Rule extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civirule_rule';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique Rule ID
   *
   * @var int
   */
  public $id;

  /**
   * @var string
   */
  public $name;

  /**
   * @var string
   */
  public $label;

  /**
   * @var int
   */
  public $trigger_id;

  /**
   * @var text
   */
  public $trigger_params;

  /**
   * @var int
   */
  public $is_active;

  /**
   * @var string
   */
  public $description;

  /**
   * @var text
   */
  public $help_text;

  /**
   * @var date
   */
  public $created_date;

  /**
   * @var int
   */
  public $created_user_id;

  /**
   * @var date
   */
  public $modified_date;

  /**
   * @var int
   */
  public $modified_user_id;

  /**
   * @var bool
   */
  public $is_debug;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civirule_rule';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Rules') : E::ts('Rule');
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'trigger_id', 'civirule_trigger', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => E::ts('Unique Rule ID'),
          'required' => TRUE,
          'where' => 'civirule_rule.id',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civirule_rule.name',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'label' => [
          'name' => 'label',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Label'),
          'maxlength' => 128,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civirule_rule.label',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'trigger_id' => [
          'name' => 'trigger_id',
          'type' => CRM_Utils_Type::T_INT,
          'where' => 'civirule_rule.trigger_id',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'FKClassName' => 'CRM_Civirules_DAO_Trigger',
          'add' => NULL,
        ],
        'trigger_params' => [
          'name' => 'trigger_params',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Trigger Params'),
          'where' => 'civirule_rule.trigger_params',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'is_active' => [
          'name' => 'is_active',
          'type' => CRM_Utils_Type::T_INT,
          'required' => TRUE,
          'where' => 'civirule_rule.is_active',
          'default' => '1',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'description' => [
          'name' => 'description',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Description'),
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'where' => 'civirule_rule.description',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'help_text' => [
          'name' => 'help_text',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Help Text'),
          'where' => 'civirule_rule.help_text',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'created_date' => [
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => E::ts('Created Date'),
          'where' => 'civirule_rule.created_date',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'created_user_id' => [
          'name' => 'created_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'where' => 'civirule_rule.created_user_id',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'modified_date' => [
          'name' => 'modified_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => E::ts('Modified Date'),
          'where' => 'civirule_rule.modified_date',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'modified_user_id' => [
          'name' => 'modified_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'where' => 'civirule_rule.modified_user_id',
          'default' => 'NULL',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
        'is_debug' => [
          'name' => 'is_debug',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'where' => 'civirule_rule.is_debug',
          'default' => '0',
          'table_name' => 'civirule_rule',
          'entity' => 'Rule',
          'bao' => 'CRM_Civirules_DAO_Rule',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, '_rule', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, '_rule', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
