# Volunteer Opportunities

After creating a [project](/projects), you must define the volunteering *opportunities* associated with the project. An opportunity is essentially a role and a time, but with a few more options and nuances.

To define opportunities, go to **Volunteers > Manage Projects**, find the project, and choose **Define volunteer opportunities**.


!!! summary "Technical note"
    "Volunteering opportunites" were formerly called "volunteering *needs*" and some of the old language still persists within the CiviVolunteer codebase and documentation.


## Characteristics of a volunteering opportunity

* **Role** - to specify what type of work is to be done, for example "Photographer", or "Clean up" *(more on [roles](#role) below)*
* **Number of volunteers needed** - when this number is reached with enough [assignments](/assignments), no further assignments will be possible
* **Time** - to specify when the volunteering is to occur (with the option of having it be open-ended)
* **Public** - to control which opportunites are available for self-service [sign-up](/sign-up-form).
* **Enabled** - to control which opportunities are available for [assignment](/assignments) by managers of the project.



## Role

Each opportunity must have a role to specify what type of work is to be done with the volunteering.

### Defining your roles {:#defining-roles}

CiviVolunteer has a few pre-defined roles, but you will likely need to add your own roles for the specific needs of your organization.

To add and edit roles, go to **Volunteers > Configure Roles**.

!!! tip
    The roles defined within CiviVolunteer are used across *all volunteering projects*, so if you plan to have a large number of projects you may want to think about what set of roles you can best define to apply to all of them.

When defining roles, you can use the **Description** field to provide additional information about the role. The description is used in the following places. 

* On the [sign-up form](/sign-up-form), a small quote bubble displays next to each role to activate a pop-up with the role description.
* The description is also written into the confirmation email sent to the volunteer after signup.


## Time

Opportunities can specify the time frame using the following different "schedule types":

* **Set Shift:** Select this schedule type for a volunteer opportunity with a specific start time and duration. *Example: Pamphleteering starts at 9:00 AM and lasts for two hours.*
* **Flexible Timeframe:** Select this schedule type for a volunteer opportunity with a specific duration but flexible dates. *Example: I need a volunteer to complete 15 hours of filing sometime during the month of December.*
* **Open-Ended:** Select this schedule type for a volunteer opportunity with no time or duration constraints. *Example: I need a volunteer graphic designer.*


