# New Features in CiviVolunteer 2.0

Thanks to [tremendous support from the CiviCRM
community](https://civicrm.org/blogs/roshani/civivolunteer-20-matching-grant-successful), CiviVolunteer 2.0 will add many improvements to your volunteer management practice.

## Volunteer Recruitment

At the heart of any volunteer program is recruitment. CiviVolunteer 2.0
makes it easy for people to identify volunteer opportunities that fit
their skills and interests. Signing up is easier than ever.

### Searchable List of Volunteer Opportunities

Though CiviVolunteer allows organizations to recruit volunteers for a
myriad of projects, it doesn’t offer a central listing of all the
available opportunities. CiviVolunteer 2.0 changes that. Volunteers are
empowered to choose the opportunities that most interest them. To start,
volunteers can search by date, type of activity, and beneficiary.

### Improved Sign Up Experience

If volunteers can browse multiple opportunities at once, why not let
them sign up for multiple opportunities at once? CiviVolunteer 2.0
introduces a shopping-cart approach to volunteer registration.
Volunteers can sign up for multiple shifts in a project—or even across
projects.

## Volunteer Management

New features will allow organizations to easily create volunteer
opportunities, manage additional roles, improve communication with
volunteers, and better measure outcomes.

### Fewer Forms, Easier Administration

New in CiviVolunteer 2.0 is a dedicated volunteer project management
interface, independent of CiviEvent. For folks whose volunteer
operations don’t center around events, the days of creating placeholders
to serve as containers for volunteer opportunities are over. Love the
volunteer/event integration? Don’t worry—nothing you’ve come to rely on
is going away.

### More Roles for Volunteer Projects

CiviVolunteer allows an organization to assign different roles to
volunteers, but what about contacts inside the organization?
CiviVolunteer 2.0 introduces new relationships to manage non-volunteer
roles in a project. The release will ship with Project Owner, Volunteer
Manager, and Beneficiary, but organizations will be able to create
arbitrary relationship types. The extension will use the Volunteer
Manager relationship to decide whom to notify about project happenings
(e.g., your project starts in a week, and you still have unfilled
positions). How will your organization use relationships?

### Improved Communication with Volunteers

From sending confirmations to new recruits, to automatically notifying
volunteers of schedule changes, to sending reminders leading up to your
project, CiviVolunteer 2.0 helps organizations build relationships with
their volunteers.

### Associate Efforts with Outcomes

An integration with CiviCampaign enables CiviVolunteer 2.0 to provide
detailed reporting across volunteer projects. Take for example an
organization planning its 10-year anniversary gala. Organizing such a
gala may require multiple volunteer projects: weeks before the event,
volunteers may join staff for an envelope stuffing party; on the day of
the event, volunteers may be used to staff the venue; etc. Using
CiviVolunteer and CiviCampaign together allows the gala organizers to
associate all the efforts (event invitations sent via post, fundraising
appeals sent electronically, volunteer hours, etc.) with their outcomes
(event registrations, donations, pledges, etc.).

